# OsiTestSolverInterface Class Reference

Vol(ume) Solver Interface. More...

`#include <OsiTestSolverInterface.hpp>`

Inheritance diagram for OsiTestSolverInterface:
[legend]
Collaboration diagram for OsiTestSolverInterface:
[legend]

List of all members.

## Classes
class | OsiVolMatrixOneMinusOne_
## Public Member Functions
virtual void | setObjSense (double s)
| Set objective function sense (1 for min (default), -1 for max,).
virtual void | setColSolution (const double *colsol)
| Set the primal solution column values.
virtual void | setRowPrice (const double *rowprice)
| Set dual solution vector.
Solve methods
virtual void | initialSolve ()
| Solve initial LP relaxation.
virtual void | resolve ()
| Resolve an LP relaxation after problem modification.
virtual void | branchAndBound ()
| Invoke solver's built-in enumeration algorithm.
Parameter set/get methods
The set methods return true if the parameter was set to the given value, false otherwise. There can be various reasons for failure: the given parameter is not applicable for the solver (e.g., refactorization frequency for the volume algorithm), the parameter is not yet implemented for the solver or simply the value of the parameter is out of the range the solver accepts. If a parameter setting call returns false check the details of your solver. The get methods return true if the given parameter is applicable for the solver and is implemented. In this case the value of the parameter is returned in the second argument. Otherwise they return false.
bool | setIntParam (OsiIntParam key, int value)
| Set an integer parameter.
bool | setDblParam (OsiDblParam key, double value)
| Set a double parameter.
bool | setStrParam (OsiStrParam key, const std::string &value)
| Set a string parameter.
bool | getIntParam (OsiIntParam key, int &value) const
| Get an integer parameter.
bool | getDblParam (OsiDblParam key, double &value) const
| Get a double parameter.
bool | getStrParam (OsiStrParam key, std::string &value) const
| Get a string parameter.
Methods returning info on how the solution process terminated
virtual bool | isAbandoned () const
| Are there a numerical difficulties?
virtual bool | isProvenOptimal () const
| Is optimality proven?
virtual bool | isProvenPrimalInfeasible () const
| Is primal infeasiblity proven?
virtual bool | isProvenDualInfeasible () const
| Is dual infeasiblity proven?
virtual bool | isPrimalObjectiveLimitReached () const
| Is the given primal objective limit reached?
virtual bool | isDualObjectiveLimitReached () const
| Is the given dual objective limit reached?
virtual bool | isIterationLimitReached () const
| Iteration limit reached?
WarmStart related methods
virtual CoinWarmStart * | getEmptyWarmStart () const
| Get an empty warm start object.
virtual CoinWarmStart * | getWarmStart () const
| Get warmstarting information.
virtual bool | setWarmStart (const CoinWarmStart *warmstart)
| Set warmstarting information.
Hotstart related methods (primarily used in strong branching). <br>
The user can create a hotstart (a snapshot) of the optimization process then reoptimize over and over again always starting from there. NOTE: between hotstarted optimizations only bound changes are allowed.
virtual void | markHotStart ()
| Create a hotstart point of the optimization process.
virtual void | solveFromHotStart ()
| Optimize starting from the hotstart.
virtual void | unmarkHotStart ()
| Delete the snapshot.
Methods related to querying the input data
virtual int | getNumCols () const
| Get number of columns.
virtual int | getNumRows () const
| Get number of rows.
virtual int | getNumElements () const
| Get number of nonzero elements.
virtual const double * | getColLower () const
| Get pointer to array[getNumCols()] of column lower bounds.
virtual const double * | getColUpper () const
| Get pointer to array[getNumCols()] of column upper bounds.
virtual const char * | getRowSense () const
| Get pointer to array[getNumRows()] of row constraint senses.
virtual const double * | getRightHandSide () const
| Get pointer to array[getNumRows()] of rows right-hand sides.
virtual const double * | getRowRange () const
| Get pointer to array[getNumRows()] of row ranges.
virtual const double * | getRowLower () const
| Get pointer to array[getNumRows()] of row lower bounds.
virtual const double * | getRowUpper () const
| Get pointer to array[getNumRows()] of row upper bounds.
virtual const double * | getObjCoefficients () const
| Get pointer to array[getNumCols()] of objective function coefficients.
virtual double | getObjSense () const
| Get objective function sense (1 for min (default), -1 for max).
virtual bool | isContinuous (int colNumber) const
| Return true if column is continuous.
virtual const CoinPackedMatrix * | getMatrixByRow () const
| Get pointer to row-wise copy of matrix.
virtual const CoinPackedMatrix * | getMatrixByCol () const
| Get pointer to column-wise copy of matrix.
virtual double | getInfinity () const
| Get solver's value for infinity.
Methods related to querying the solution
virtual const double * | getColSolution () const
| Get pointer to array[getNumCols()] of primal solution vector.
virtual const double * | getRowPrice () const
| Get pointer to array[getNumRows()] of dual prices.
virtual const double * | getReducedCost () const
| Get a pointer to array[getNumCols()] of reduced costs.
virtual const double * | getRowActivity () const
| Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.
virtual double | getObjValue () const
| Get objective function value.
virtual int | getIterationCount () const
| Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.
virtual std::vector< double * > | getDualRays (int maxNumRays, bool fullRay=false) const
| Get as many dual rays as the solver can provide.
virtual std::vector< double * > | getPrimalRays (int maxNumRays) const
| Get as many primal rays as the solver can provide.
Changing bounds on variables and constraints
virtual void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient.
virtual void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -COIN_DBL_MAX for -infinity.
virtual void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use COIN_DBL_MAX for infinity.
virtual void | setColBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound.
virtual void | setColSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously The default implementation just invokes setColLower() and setColUpper() over and over again.
virtual void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound Use -COIN_DBL_MAX for -infinity.
virtual void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound Use COIN_DBL_MAX for infinity.
virtual void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound.
virtual void | setRowType (int index, char sense, double rightHandSide, double range)
| Set the type of a single row .
virtual void | setRowSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of rows simultaneously The default implementation just invokes setRowLower() and setRowUpper() over and over again.
virtual void | setRowSetTypes (const int *indexFirst, const int *indexLast, const char *senseList, const double *rhsList, const double *rangeList)
| Set the type of a number of rows simultaneously The default implementation just invokes setRowType() over and over again.
Integrality related changing methods
virtual void | setContinuous (int index)
| Set the index-th variable to be a continuous variable.
virtual void | setInteger (int index)
| Set the index-th variable to be an integer variable.
virtual void | setContinuous (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be continuous variables.
virtual void | setInteger (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be integer variables.
Methods to expand a problem.<br>
Note that if a column is added then by default it will correspond to a continuous variable.
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj)
| Add a column (primal variable) to the problem.
virtual void | addCols (const int numcols, const CoinPackedVectorBase *const *cols, const double *collb, const double *colub, const double *obj)
| Add a set of columns (primal variables) to the problem.
virtual void | deleteCols (const int num, const int *colIndices)
| Remove a set of columns (primal variables) from the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub)
| Add a row (constraint) to the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng)
| Add a row (constraint) to the problem.
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const double *rowlb, const double *rowub)
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const char *rowsen, const double *rowrhs, const double *rowrng)
| Add a set of rows (constraints) to the problem.
virtual void | deleteRows (const int num, const int *rowIndices)
| Delete a set of rows (constraints) from the problem.
Methods to input a problem
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, double *&rowlb, double *&rowub)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, char *&rowsen, double *&rowrhs, double *&rowrng)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual int | readMps (const char *filename, const char *extension="mps")
| Read an mps file from the given filename.
virtual void | writeMps (const char *filename, const char *extension="mps", double objSense=0.0) const
| Write the problem into an mps file of the given filename.
OSL specific public interfaces
VOL_problem * | volprob ()
| Get pointer to Vol model.
Constructors and destructors
| OsiTestSolverInterface ()
| Default Constructor.
virtual OsiSolverInterface * | clone (bool copyData=true) const
| Clone.
| OsiTestSolverInterface (const OsiTestSolverInterface &)
| Copy constructor.
OsiTestSolverInterface & | operator= (const OsiTestSolverInterface &rhs)
| Assignment operator.
virtual | ~OsiTestSolverInterface ()
| Destructor.
## Protected Member Functions
Helper methods for problem input
void | initFromRlbRub (const int rownum, const double *rowlb, const double *rowub)
void | initFromRhsSenseRange (const int rownum, const char *rowsen, const double *rowrhs, const double *rowrng)
void | initFromClbCubObj (const int colnum, const double *collb, const double *colub, const double *obj)
Protected methods
virtual void | applyRowCut (const OsiRowCut &rc)
| Apply a row cut (append to constraint matrix).
virtual void | applyColCut (const OsiColCut &cc)
| Apply a column cut (adjust one or more bounds).
## Private Member Functions
Methods of <code>VOL_user_hooks</code>
virtual int | compute_rc (const VOL_dvector &u, VOL_dvector &rc)
| compute reduced costs
virtual int | solve_subproblem (const VOL_dvector &dual, const VOL_dvector &rc, double &lcost, VOL_dvector &x, VOL_dvector &v, double &pcost)
| Solve the subproblem for the subgradient step.
virtual int | heuristics (const VOL_problem &, const VOL_dvector &, double &heur_val)
| Starting from the primal vector x, run a heuristic to produce an integer solution.
Private helper methods
void | updateRowMatrix_ () const
| Update the row ordered matrix from the column ordered one.
void | updateColMatrix_ () const
| Update the column ordered matrix from the row ordered one.
void | checkData_ () const
| Test whether the Volume Algorithm can be applied to the given problem.
void | compute_rc_ (const double *u, double *rc) const
| Compute the reduced costs (`rc`) with respect to the dual values given in `u`.
void | gutsOfDestructor_ ()
| A method deleting every member data.
void | rowRimAllocator_ ()
| A method allocating sufficient space for the rim vectors corresponding to the rows.
void | colRimAllocator_ ()
| A method allocating sufficient space for the rim vectors corresponding to the columns.
void | rowRimResize_ (const int newSize)
| Reallocate the rim arrays corresponding to the rows.
void | colRimResize_ (const int newSize)
| Reallocate the rim arrays corresponding to the columns.
void | convertBoundsToSenses_ ()
| For each row convert LB/UB style row constraints to sense/rhs style.
void | convertSensesToBounds_ ()
| For each row convert sense/rhs style row constraints to LB/UB style.
bool | test_zero_one_minusone_ (const CoinPackedMatrix &m) const
| test whether the given matrix is 0/1/-1 entries only.
## Private Attributes
double | objsense_
| Sense of objective (1 for min; -1 for max).
double * | rowpriceHotStart_
| An array to store the hotstart information between solveHotStart() calls.
int | maxNumrows_
| allocated size of the row related rim vectors
int | maxNumcols_
| allocated size of the column related rim vectors
VOL_problem | volprob_
| The volume solver.
The problem matrix in row and column ordered forms <br>
Note that at least one of the matrices is always current.
bool | rowMatrixCurrent_
| A flag indicating whether the row ordered matrix is up-to-date.
CoinPackedMatrix | rowMatrix_
| The problem matrix in a row ordered form.
bool | colMatrixCurrent_
| A flag indicating whether the column ordered matrix is up-to-date.
CoinPackedMatrix | colMatrix_
| The problem matrix in a column ordered form.
Data members used when 0/1/-1 matrix is detected
bool | isZeroOneMinusOne_
| An indicator whether the matrix is 0/1/-1.
OsiVolMatrixOneMinusOne_ * | rowMatrixOneMinusOne_
| The row ordered matrix without the elements.
OsiVolMatrixOneMinusOne_ * | colMatrixOneMinusOne_
| The column ordered matrix without the elements.
The rim vectors
double * | colupper_
| Pointer to dense vector of structural variable upper bounds.
double * | collower_
| Pointer to dense vector of structural variable lower bounds.
bool * | continuous_
| Pointer to dense vector of bool to indicate if column is continuous.
double * | rowupper_
| Pointer to dense vector of slack variable upper bounds.
double * | rowlower_
| Pointer to dense vector of slack variable lower bounds.
char * | rowsense_
| Pointer to dense vector of row sense indicators.
double * | rhs_
| Pointer to dense vector of row right-hand side values.
double * | rowrange_
| Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).
double * | objcoeffs_
| Pointer to dense vector of objective coefficients.
The solution
double * | colsol_
| Pointer to dense vector of primal structural variable values.
double * | rowprice_
| Pointer to dense vector of dual row variable values.
double * | rc_
| Pointer to dense vector of reduced costs.
double * | lhs_
| Pointer to dense vector of left hand sides (row activity levels).
double | lagrangeanCost_
| The Lagrangean cost, a lower bound on the objective value.
## Friends
void | OsiTestSolverInterfaceUnitTest (const std::string &mpsDir, const std::string &netlibDir)
| A function that tests the methods in the OsiTestSolverInterface class.

## Detailed Description

Vol(ume) Solver Interface.

Instantiation of OsiTestSolverInterface for the Volume Algorithm

Definition at line 27 of file OsiTestSolverInterface.hpp.

## Constructor & Destructor Documentation

OsiTestSolverInterface::OsiTestSolverInterface | ( |  | ) |

Default Constructor.

OsiTestSolverInterface::OsiTestSolverInterface | ( | const OsiTestSolverInterface & |  | ) |

Copy constructor.

virtual OsiTestSolverInterface::~OsiTestSolverInterface | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual void OsiTestSolverInterface::initialSolve | ( |  | ) | `[virtual]`

Solve initial LP relaxation.

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::resolve | ( |  | ) | `[virtual]`

Resolve an LP relaxation after problem modification.

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::branchAndBound | ( |  | ) | `[inline, virtual]`

Invoke solver's built-in enumeration algorithm.

Implements OsiSolverInterface.

Definition at line 63 of file OsiTestSolverInterface.hpp.

bool OsiTestSolverInterface::setIntParam | ( | OsiIntParam | key,
|  | int | value |
| ) |  |  | `[virtual]`

Set an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiTestSolverInterface::setDblParam | ( | OsiDblParam | key,
|  | double | value |
| ) |  |  | `[virtual]`

Set a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiTestSolverInterface::setStrParam | ( | OsiStrParam | key,
|  | const std::string & | value |
| ) |  |  | `[virtual]`

Set a string parameter.

Reimplemented from OsiSolverInterface.

bool OsiTestSolverInterface::getIntParam | ( | OsiIntParam | key,
|  | int & | value |
| ) |  |  | const`[virtual]`

Get an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiTestSolverInterface::getDblParam | ( | OsiDblParam | key,
|  | double & | value |
| ) |  |  | const`[virtual]`

Get a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiTestSolverInterface::getStrParam | ( | OsiStrParam | key,
|  | std::string & | value |
| ) |  |  | const`[virtual]`

Get a string parameter.

Reimplemented from OsiSolverInterface.

virtual bool OsiTestSolverInterface::isAbandoned | ( |  | ) | const`[virtual]`

Are there a numerical difficulties?

Implements OsiSolverInterface.

virtual bool OsiTestSolverInterface::isProvenOptimal | ( |  | ) | const`[virtual]`

Is optimality proven?

Implements OsiSolverInterface.

virtual bool OsiTestSolverInterface::isProvenPrimalInfeasible | ( |  | ) | const`[virtual]`

Is primal infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiTestSolverInterface::isProvenDualInfeasible | ( |  | ) | const`[virtual]`

Is dual infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiTestSolverInterface::isPrimalObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given primal objective limit reached?

Reimplemented from OsiSolverInterface.

virtual bool OsiTestSolverInterface::isDualObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given dual objective limit reached?

Reimplemented from OsiSolverInterface.

virtual bool OsiTestSolverInterface::isIterationLimitReached | ( |  | ) | const`[virtual]`

Iteration limit reached?

Implements OsiSolverInterface.

virtual CoinWarmStart* OsiTestSolverInterface::getEmptyWarmStart | ( |  | ) | const`[virtual]`

Get an empty warm start object.

This routine returns an empty warm start object. Its purpose is to provide a way to give a client a warm start object of the appropriate type, which can resized and modified as desired.

Implements OsiSolverInterface.

virtual CoinWarmStart* OsiTestSolverInterface::getWarmStart | ( |  | ) | const`[virtual]`

Get warmstarting information.

Implements OsiSolverInterface.

virtual bool OsiTestSolverInterface::setWarmStart | ( | const CoinWarmStart * | warmstart | ) | `[virtual]`

Set warmstarting information.

Return true/false depending on whether the warmstart information was accepted or not.

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::markHotStart | ( |  | ) | `[virtual]`

Create a hotstart point of the optimization process.

Reimplemented from OsiSolverInterface.

virtual void OsiTestSolverInterface::solveFromHotStart | ( |  | ) | `[virtual]`

Optimize starting from the hotstart.

Reimplemented from OsiSolverInterface.

virtual void OsiTestSolverInterface::unmarkHotStart | ( |  | ) | `[virtual]`

Delete the snapshot.

Reimplemented from OsiSolverInterface.

virtual int OsiTestSolverInterface::getNumCols | ( |  | ) | const`[inline, virtual]`

Get number of columns.

Implements OsiSolverInterface.

Definition at line 167 of file OsiTestSolverInterface.hpp.

virtual int OsiTestSolverInterface::getNumRows | ( |  | ) | const`[inline, virtual]`

Get number of rows.

Implements OsiSolverInterface.

Definition at line 172 of file OsiTestSolverInterface.hpp.

virtual int OsiTestSolverInterface::getNumElements | ( |  | ) | const`[inline, virtual]`

Get number of nonzero elements.

Implements OsiSolverInterface.

Definition at line 177 of file OsiTestSolverInterface.hpp.

virtual const double* OsiTestSolverInterface::getColLower | ( |  | ) | const`[inline, virtual]`

Get pointer to array[getNumCols()] of column lower bounds.

Implements OsiSolverInterface.

Definition at line 182 of file OsiTestSolverInterface.hpp.

virtual const double* OsiTestSolverInterface::getColUpper | ( |  | ) | const`[inline, virtual]`

Get pointer to array[getNumCols()] of column upper bounds.

Implements OsiSolverInterface.

Definition at line 185 of file OsiTestSolverInterface.hpp.

virtual const char* OsiTestSolverInterface::getRowSense | ( |  | ) | const`[inline, virtual]`

Get pointer to array[getNumRows()] of row constraint senses.

- 'L' <= constraint
- 'E' = constraint
- 'G' >= constraint
- 'R' ranged constraint
- 'N' free constraint

Implements OsiSolverInterface.

Definition at line 196 of file OsiTestSolverInterface.hpp.

virtual const double* OsiTestSolverInterface::getRightHandSide | ( |  | ) | const`[inline, virtual]`

Get pointer to array[getNumRows()] of rows right-hand sides.

- if rowsense()[i] == 'L' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'G' then rhs()[i] == rowlower()[i]
- if rowsense()[i] == 'R' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'N' then rhs()[i] == 0.0

Implements OsiSolverInterface.

Definition at line 206 of file OsiTestSolverInterface.hpp.

virtual const double* OsiTestSolverInterface::getRowRange | ( |  | ) | const`[inline, virtual]`

Get pointer to array[getNumRows()] of row ranges.

- if rowsense()[i] == 'R' then rowrange()[i] == rowupper()[i] - rowlower()[i]
- if rowsense()[i] != 'R' then rowrange()[i] is undefined

Implements OsiSolverInterface.

Definition at line 216 of file OsiTestSolverInterface.hpp.

virtual const double* OsiTestSolverInterface::getRowLower | ( |  | ) | const`[inline, virtual]`

Get pointer to array[getNumRows()] of row lower bounds.

Implements OsiSolverInterface.

Definition at line 219 of file OsiTestSolverInterface.hpp.

virtual const double* OsiTestSolverInterface::getRowUpper | ( |  | ) | const`[inline, virtual]`

Get pointer to array[getNumRows()] of row upper bounds.

Implements OsiSolverInterface.

Definition at line 222 of file OsiTestSolverInterface.hpp.

virtual const double* OsiTestSolverInterface::getObjCoefficients | ( |  | ) | const`[inline, virtual]`

Get pointer to array[getNumCols()] of objective function coefficients.

Implements OsiSolverInterface.

Definition at line 225 of file OsiTestSolverInterface.hpp.

virtual double OsiTestSolverInterface::getObjSense | ( |  | ) | const`[inline, virtual]`

Get objective function sense (1 for min (default), -1 for max).

Implements OsiSolverInterface.

Definition at line 228 of file OsiTestSolverInterface.hpp.

virtual bool OsiTestSolverInterface::isContinuous | ( | int | colNumber | ) | const`[virtual]`

Return true if column is continuous.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiTestSolverInterface::getMatrixByRow | ( |  | ) | const`[virtual]`

Get pointer to row-wise copy of matrix.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiTestSolverInterface::getMatrixByCol | ( |  | ) | const`[virtual]`

Get pointer to column-wise copy of matrix.

Implements OsiSolverInterface.

virtual double OsiTestSolverInterface::getInfinity | ( |  | ) | const`[inline, virtual]`

Get solver's value for infinity.

Implements OsiSolverInterface.

Definition at line 257 of file OsiTestSolverInterface.hpp.

virtual const double* OsiTestSolverInterface::getColSolution | ( |  | ) | const`[inline, virtual]`

Get pointer to array[getNumCols()] of primal solution vector.

Implements OsiSolverInterface.

Definition at line 263 of file OsiTestSolverInterface.hpp.

virtual const double* OsiTestSolverInterface::getRowPrice | ( |  | ) | const`[inline, virtual]`

Get pointer to array[getNumRows()] of dual prices.

Implements OsiSolverInterface.

Definition at line 266 of file OsiTestSolverInterface.hpp.

virtual const double* OsiTestSolverInterface::getReducedCost | ( |  | ) | const`[inline, virtual]`

Get a pointer to array[getNumCols()] of reduced costs.

Implements OsiSolverInterface.

Definition at line 269 of file OsiTestSolverInterface.hpp.

virtual const double* OsiTestSolverInterface::getRowActivity | ( |  | ) | const`[inline, virtual]`

Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.

Implements OsiSolverInterface.

Definition at line 273 of file OsiTestSolverInterface.hpp.

virtual double OsiTestSolverInterface::getObjValue | ( |  | ) | const`[inline, virtual]`

Get objective function value.

Implements OsiSolverInterface.

Definition at line 276 of file OsiTestSolverInterface.hpp.

virtual int OsiTestSolverInterface::getIterationCount | ( |  | ) | const`[inline, virtual]`

Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.

Implements OsiSolverInterface.

Definition at line 287 of file OsiTestSolverInterface.hpp.

virtual std::vector<double*> OsiTestSolverInterface::getDualRays | ( | int | maxNumRays,
|  | bool | fullRay = `false` |
| ) |  |  | const`[virtual]`

Get as many dual rays as the solver can provide.

(In case of proven primal infeasibility there should be at least one.)

The first getNumRows() ray components will always be associated with the row duals (as returned by getRowPrice()). If `fullRay` is true, the final getNumCols() entries will correspond to the ray components associated with the nonbasic variables. If the full ray is requested and the method cannot provide it, it will throw an exception.

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumRows() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual std::vector<double*> OsiTestSolverInterface::getPrimalRays | ( | int | maxNumRays | ) | const`[virtual]`

Get as many primal rays as the solver can provide.

(In case of proven dual infeasibility there should be at least one.)

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumCols() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[inline, virtual]`

Set an objective function coefficient.

Implements OsiSolverInterface.

Definition at line 338 of file OsiTestSolverInterface.hpp.

virtual void OsiTestSolverInterface::setColLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[inline, virtual]`

Set a single column lower bound
Use -COIN_DBL_MAX for -infinity.

Implements OsiSolverInterface.

Definition at line 345 of file OsiTestSolverInterface.hpp.

virtual void OsiTestSolverInterface::setColUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[inline, virtual]`

Set a single column upper bound
Use COIN_DBL_MAX for infinity.

Implements OsiSolverInterface.

Definition at line 352 of file OsiTestSolverInterface.hpp.

virtual void OsiTestSolverInterface::setColBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[inline, virtual]`

Set a single column lower and upper bound.

Reimplemented from OsiSolverInterface.

Definition at line 357 of file OsiTestSolverInterface.hpp.

virtual void OsiTestSolverInterface::setColSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a number of columns simultaneously
The default implementation just invokes setColLower() and setColUpper() over and over again.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the variables whose either bound changes
  | boundList | the new lower/upper bound pairs for the variables

Reimplemented from OsiSolverInterface.

virtual void OsiTestSolverInterface::setRowLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[inline, virtual]`

Set a single row lower bound
Use -COIN_DBL_MAX for -infinity.

Implements OsiSolverInterface.

Definition at line 377 of file OsiTestSolverInterface.hpp.

virtual void OsiTestSolverInterface::setRowUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[inline, virtual]`

Set a single row upper bound
Use COIN_DBL_MAX for infinity.

Implements OsiSolverInterface.

Definition at line 386 of file OsiTestSolverInterface.hpp.

virtual void OsiTestSolverInterface::setRowBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[inline, virtual]`

Set a single row lower and upper bound.

Reimplemented from OsiSolverInterface.

Definition at line 394 of file OsiTestSolverInterface.hpp.

virtual void OsiTestSolverInterface::setRowType | ( | int | index,
|  | char | sense,
|  | double | rightHandSide,
|  | double | range |
| ) |  |  | `[inline, virtual]`

Set the type of a single row
.

Implements OsiSolverInterface.

Definition at line 404 of file OsiTestSolverInterface.hpp.

virtual void OsiTestSolverInterface::setRowSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a number of rows simultaneously
The default implementation just invokes setRowLower() and setRowUpper() over and over again.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the constraints whose either bound changes
  | boundList | the new lower/upper bound pairs for the constraints

Reimplemented from OsiSolverInterface.

virtual void OsiTestSolverInterface::setRowSetTypes | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const char * | senseList,
|  | const double * | rhsList,
|  | const double * | rangeList |
| ) |  |  | `[virtual]`

Set the type of a number of rows simultaneously
The default implementation just invokes setRowType() over and over again.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the constraints whose any characteristics changes
  | senseList | the new senses
  | rhsList | the new right hand sides
  | rangeList | the new ranges

Reimplemented from OsiSolverInterface.

virtual void OsiTestSolverInterface::setContinuous | ( | int | index | ) | `[virtual]`

Set the index-th variable to be a continuous variable.

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::setInteger | ( | int | index | ) | `[virtual]`

Set the index-th variable to be an integer variable.

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::setContinuous | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be continuous variables.

Reimplemented from OsiSolverInterface.

virtual void OsiTestSolverInterface::setInteger | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be integer variables.

Reimplemented from OsiSolverInterface.

virtual void OsiTestSolverInterface::setObjSense | ( | double | s | ) | `[inline, virtual]`

Set objective function sense (1 for min (default), -1 for max,).

Implements OsiSolverInterface.

Definition at line 459 of file OsiTestSolverInterface.hpp.

virtual void OsiTestSolverInterface::setColSolution | ( | const double * | colsol | ) | `[virtual]`

Set the primal solution column values.

colsol[numcols()] is an array of values of the problem column variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of colsol() until changed by another call to setColsol() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::setRowPrice | ( | const double * | rowprice | ) | `[virtual]`

Set dual solution vector.

rowprice[numrows()] is an array of values of the problem row dual variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of rowprice() until changed by another call to setRowprice() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::addCol | ( | const CoinPackedVectorBase & | vec,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj |
| ) |  |  | `[virtual]`

Add a column (primal variable) to the problem.

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::addCols | ( | const int | numcols,
|  | const CoinPackedVectorBase *const * | cols,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj |
| ) |  |  | `[virtual]`

Add a set of columns (primal variables) to the problem.

The default implementation simply makes repeated calls to addCol().

Reimplemented from OsiSolverInterface.

virtual void OsiTestSolverInterface::deleteCols | ( | const int | num,
|  | const int * | colIndices |
| ) |  |  | `[virtual]`

Remove a set of columns (primal variables) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted variables are nonbasic.

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const double | rowlb,
|  | const double | rowub |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const char | rowsen,
|  | const double | rowrhs,
|  | const double | rowrng |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiTestSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiTestSolverInterface::deleteRows | ( | const int | num,
|  | const int * | rowIndices |
| ) |  |  | `[virtual]`

Delete a set of rows (constraints) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted rows are loose.

Implements OsiSolverInterface.

void OsiTestSolverInterface::initFromRlbRub | ( | const int | rownum,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[protected]`

void OsiTestSolverInterface::initFromRhsSenseRange | ( | const int | rownum,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[protected]`

void OsiTestSolverInterface::initFromClbCubObj | ( | const int | colnum,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj |
| ) |  |  | `[protected]`

virtual void OsiTestSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `rowub`: all rows have upper bound infinity
- `rowlb`: all rows have lower bound -infinity
- `obj`: all variables have 0 objective coefficient

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | double *& | rowlb,
|  | double *& | rowub |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `obj`: all variables have 0 objective coefficient
- `rowsen`: all rows are >=
- `rowrhs`: all right hand sides are 0
- `rowrng`: 0 for the ranged rows

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | char *& | rowsen,
|  | double *& | rowrhs,
|  | double *& | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual int OsiTestSolverInterface::readMps | ( | const char * | filename,
|  | const char * | extension = `"mps"` |
| ) |  |  | `[virtual]`

Read an mps file from the given filename.

Reimplemented from OsiSolverInterface.

virtual void OsiTestSolverInterface::writeMps | ( | const char * | filename,
|  | const char * | extension = `"mps"`,
|  | double | objSense = `0.0` |
| ) |  |  | const`[virtual]`

Write the problem into an mps file of the given filename.

If objSense is non zero then -1.0 forces the code to write a maximization objective and +1.0 to write a minimization one. If 0.0 then solver can do what it wants

Implements OsiSolverInterface.

VOL_problem* OsiTestSolverInterface::volprob | ( |  | ) | `[inline]`

Get pointer to Vol model.

Definition at line 681 of file OsiTestSolverInterface.hpp.

virtual OsiSolverInterface* OsiTestSolverInterface::clone | ( | bool | copyData = `true` | ) | const`[virtual]`

Clone.

Implements OsiSolverInterface.

OsiTestSolverInterface& OsiTestSolverInterface::operator= | ( | const OsiTestSolverInterface & | rhs | ) |

Assignment operator.

Reimplemented from OsiSolverInterface.

virtual void OsiTestSolverInterface::applyRowCut | ( | const OsiRowCut & | rc | ) | `[protected, virtual]`

Apply a row cut (append to constraint matrix).

Implements OsiSolverInterface.

virtual void OsiTestSolverInterface::applyColCut | ( | const OsiColCut & | cc | ) | `[protected, virtual]`

Apply a column cut (adjust one or more bounds).

Implements OsiSolverInterface.

virtual int OsiTestSolverInterface::compute_rc | ( | const VOL_dvector & | u,
|  | VOL_dvector & | rc |
| ) |  |  | `[private, virtual]`

compute reduced costs

Implements VOL_user_hooks.

virtual int OsiTestSolverInterface::solve_subproblem | ( | const VOL_dvector & | dual,
|  | const VOL_dvector & | rc,
|  | double & | lcost,
|  | VOL_dvector & | x,
|  | VOL_dvector & | v,
|  | double & | pcost |
| ) |  |  | `[private, virtual]`

Solve the subproblem for the subgradient step.

Implements VOL_user_hooks.

virtual int OsiTestSolverInterface::heuristics | ( | const VOL_problem & | ,
|  | const VOL_dvector & | ,
|  | double & | heur_val |
| ) |  |  | `[inline, private, virtual]`

Starting from the primal vector x, run a heuristic to produce an integer solution.

This is not done in LP solving.

Implements VOL_user_hooks.

Definition at line 730 of file OsiTestSolverInterface.hpp.

void OsiTestSolverInterface::updateRowMatrix_ | ( |  | ) | const`[private]`

Update the row ordered matrix from the column ordered one.

void OsiTestSolverInterface::updateColMatrix_ | ( |  | ) | const`[private]`

Update the column ordered matrix from the row ordered one.

void OsiTestSolverInterface::checkData_ | ( |  | ) | const`[private]`

Test whether the Volume Algorithm can be applied to the given problem.

void OsiTestSolverInterface::compute_rc_ | ( | const double * | u,
|  | double * | rc |
| ) |  |  | const`[private]`

Compute the reduced costs (`rc`) with respect to the dual values given in `u`.

void OsiTestSolverInterface::gutsOfDestructor_ | ( |  | ) | `[private]`

A method deleting every member data.

void OsiTestSolverInterface::rowRimAllocator_ | ( |  | ) | `[private]`

A method allocating sufficient space for the rim vectors corresponding to the rows.

void OsiTestSolverInterface::colRimAllocator_ | ( |  | ) | `[private]`

A method allocating sufficient space for the rim vectors corresponding to the columns.

void OsiTestSolverInterface::rowRimResize_ | ( | const int | newSize | ) | `[private]`

Reallocate the rim arrays corresponding to the rows.

void OsiTestSolverInterface::colRimResize_ | ( | const int | newSize | ) | `[private]`

Reallocate the rim arrays corresponding to the columns.

void OsiTestSolverInterface::convertBoundsToSenses_ | ( |  | ) | `[private]`

For each row convert LB/UB style row constraints to sense/rhs style.

void OsiTestSolverInterface::convertSensesToBounds_ | ( |  | ) | `[private]`

For each row convert sense/rhs style row constraints to LB/UB style.

bool OsiTestSolverInterface::test_zero_one_minusone_ | ( | const CoinPackedMatrix & | m | ) | const`[private]`

test whether the given matrix is 0/1/-1 entries only.

## Friends And Related Function Documentation

void OsiTestSolverInterfaceUnitTest | ( | const std::string & | mpsDir,
|  | const std::string & | netlibDir |
| ) |  |  | `[friend]`

A function that tests the methods in the OsiTestSolverInterface class.

## Member Data Documentation

bool OsiTestSolverInterface::rowMatrixCurrent_`[mutable, private]`

A flag indicating whether the row ordered matrix is up-to-date.

Definition at line 786 of file OsiTestSolverInterface.hpp.

CoinPackedMatrix OsiTestSolverInterface::rowMatrix_`[mutable, private]`

The problem matrix in a row ordered form.

Definition at line 788 of file OsiTestSolverInterface.hpp.

bool OsiTestSolverInterface::colMatrixCurrent_`[mutable, private]`

A flag indicating whether the column ordered matrix is up-to-date.

Definition at line 790 of file OsiTestSolverInterface.hpp.

CoinPackedMatrix OsiTestSolverInterface::colMatrix_`[mutable, private]`

The problem matrix in a column ordered form.

Definition at line 792 of file OsiTestSolverInterface.hpp.

bool OsiTestSolverInterface::isZeroOneMinusOne_`[private]`

An indicator whether the matrix is 0/1/-1.

Definition at line 799 of file OsiTestSolverInterface.hpp.

OsiVolMatrixOneMinusOne_* OsiTestSolverInterface::rowMatrixOneMinusOne_`[private]`

The row ordered matrix without the elements.

Definition at line 801 of file OsiTestSolverInterface.hpp.

OsiVolMatrixOneMinusOne_* OsiTestSolverInterface::colMatrixOneMinusOne_`[private]`

The column ordered matrix without the elements.

Definition at line 803 of file OsiTestSolverInterface.hpp.

double* OsiTestSolverInterface::colupper_`[private]`

Pointer to dense vector of structural variable upper bounds.

Definition at line 810 of file OsiTestSolverInterface.hpp.

double* OsiTestSolverInterface::collower_`[private]`

Pointer to dense vector of structural variable lower bounds.

Definition at line 812 of file OsiTestSolverInterface.hpp.

bool* OsiTestSolverInterface::continuous_`[private]`

Pointer to dense vector of bool to indicate if column is continuous.

Definition at line 814 of file OsiTestSolverInterface.hpp.

double* OsiTestSolverInterface::rowupper_`[private]`

Pointer to dense vector of slack variable upper bounds.

Definition at line 816 of file OsiTestSolverInterface.hpp.

double* OsiTestSolverInterface::rowlower_`[private]`

Pointer to dense vector of slack variable lower bounds.

Definition at line 818 of file OsiTestSolverInterface.hpp.

char* OsiTestSolverInterface::rowsense_`[private]`

Pointer to dense vector of row sense indicators.

Definition at line 820 of file OsiTestSolverInterface.hpp.

double* OsiTestSolverInterface::rhs_`[private]`

Pointer to dense vector of row right-hand side values.

Definition at line 822 of file OsiTestSolverInterface.hpp.

double* OsiTestSolverInterface::rowrange_`[private]`

Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).

Definition at line 825 of file OsiTestSolverInterface.hpp.

double* OsiTestSolverInterface::objcoeffs_`[private]`

Pointer to dense vector of objective coefficients.

Definition at line 827 of file OsiTestSolverInterface.hpp.

double OsiTestSolverInterface::objsense_`[private]`

Sense of objective (1 for min; -1 for max).

Definition at line 832 of file OsiTestSolverInterface.hpp.

double* OsiTestSolverInterface::colsol_`[private]`

Pointer to dense vector of primal structural variable values.

Definition at line 838 of file OsiTestSolverInterface.hpp.

double* OsiTestSolverInterface::rowprice_`[private]`

Pointer to dense vector of dual row variable values.

Definition at line 840 of file OsiTestSolverInterface.hpp.

double* OsiTestSolverInterface::rc_`[private]`

Pointer to dense vector of reduced costs.

Definition at line 842 of file OsiTestSolverInterface.hpp.

double* OsiTestSolverInterface::lhs_`[private]`

Pointer to dense vector of left hand sides (row activity levels).

Definition at line 844 of file OsiTestSolverInterface.hpp.

double OsiTestSolverInterface::lagrangeanCost_`[private]`

The Lagrangean cost, a lower bound on the objective value.

Definition at line 846 of file OsiTestSolverInterface.hpp.

double* OsiTestSolverInterface::rowpriceHotStart_`[private]`

An array to store the hotstart information between solveHotStart() calls.

Definition at line 852 of file OsiTestSolverInterface.hpp.

int OsiTestSolverInterface::maxNumrows_`[private]`

allocated size of the row related rim vectors

Definition at line 855 of file OsiTestSolverInterface.hpp.

int OsiTestSolverInterface::maxNumcols_`[private]`

allocated size of the column related rim vectors

Definition at line 857 of file OsiTestSolverInterface.hpp.

VOL_problem OsiTestSolverInterface::volprob_`[private]`

The volume solver.

Definition at line 860 of file OsiTestSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Blis-0.94.1/Osi/test/OsiTestSolverInterface.hpp